diff --git a/src/backend/postmaster/pgstat.c b/src/backend/postmaster/pgstat.c
index fc104b52603..fb4e858332a 100644
--- a/src/backend/postmaster/pgstat.c
+++ b/src/backend/postmaster/pgstat.c
@@ -2912,1533 +1735,958 @@ pgstat_read_db_statsfile(Oid databaseid, HTAB *tabhash, HTAB *funchash,
 done:
 	FreeFile(fpin);
 
-	if (permanent)
-	{
-		elog(DEBUG2, "removing permanent stats file \"%s\"", statfile);
-		unlink(statfile);
-	}
+	elog(DEBUG2, "removing permanent stats file \"%s\"", statfile);
+	unlink(statfile);
+
+	return;
 }
 
-/* ----------
- * pgstat_read_db_statsfile_timestamp() -
- *
- *	Attempt to determine the timestamp of the last db statfile write.
- *	Returns true if successful; the timestamp is stored in *ts. The caller must
- *	rely on timestamp stored in *ts iff the function returns true.
- *
- *	This needs to be careful about handling databases for which no stats file
- *	exists, such as databases without a stat entry or those not yet written:
- *
- *	- if there's a database entry in the global file, return the corresponding
- *	stats_timestamp value.
- *
- *	- if there's no db stat entry (e.g. for a new or inactive database),
- *	there's no stats_timestamp value, but also nothing to write so we return
- *	the timestamp of the global statfile.
- * ----------
- */
-static bool
-pgstat_read_db_statsfile_timestamp(Oid databaseid, bool permanent,
-								   TimestampTz *ts)
+static PgStatShm_StatEntryHeader *
+pgstat_shared_stat_entry_init(PgStatKind kind,
+							  PgStatShmHashEntry *shhashent,
+							  int init_refcount)
 {
-	PgStat_StatDBEntry dbentry;
-	PgStat_GlobalStats myGlobalStats;
-	PgStat_ArchiverStats myArchiverStats;
-	PgStat_WalStats myWalStats;
-	PgStat_SLRUStats mySLRUStats[SLRU_NUM_ELEMENTS];
-	PgStat_StatReplSlotEntry myReplSlotStats;
-	PgStat_StatSubEntry mySubStats;
-	FILE	   *fpin;
-	int32		format_id;
-	const char *statfile = permanent ? PGSTAT_STAT_PERMANENT_FILENAME : pgstat_stat_filename;
+	/* Create new stats entry. */
+	dsa_pointer chunk;
+	PgStatShm_StatEntryHeader *shheader;
 
-	/*
-	 * Try to open the stats file.  As above, anything but ENOENT is worthy of
-	 * complaining about.
-	 */
-	if ((fpin = AllocateFile(statfile, PG_BINARY_R)) == NULL)
-	{
-		if (errno != ENOENT)
-			ereport(pgStatRunningInCollector ? LOG : WARNING,
-					(errcode_for_file_access(),
-					 errmsg("could not open statistics file \"%s\": %m",
-							statfile)));
-		return false;
-	}
+	LWLockInitialize(&shhashent->lock, LWTRANCHE_STATS);
+	pg_atomic_init_u32(&shhashent->refcount, init_refcount);
+	shhashent->dropped = false;
 
-	/*
-	 * Verify it's of the expected format.
-	 */
-	if (fread(&format_id, 1, sizeof(format_id), fpin) != sizeof(format_id) ||
-		format_id != PGSTAT_FILE_FORMAT_ID)
-	{
-		ereport(pgStatRunningInCollector ? LOG : WARNING,
-				(errmsg("corrupted statistics file \"%s\"", statfile)));
-		FreeFile(fpin);
-		return false;
-	}
+	chunk = dsa_allocate0(pgStatDSA, pgstat_kind_infos[kind].shared_size);
+	shheader = dsa_get_address(pgStatDSA, chunk);
+	shheader->magic = 0xdeadbeef;
 
-	/*
-	 * Read global stats struct
-	 */
-	if (fread(&myGlobalStats, 1, sizeof(myGlobalStats),
-			  fpin) != sizeof(myGlobalStats))
-	{
-		ereport(pgStatRunningInCollector ? LOG : WARNING,
-				(errmsg("corrupted statistics file \"%s\"", statfile)));
-		FreeFile(fpin);
-		return false;
-	}
+	/* Link the new entry from the hash entry. */
+	shhashent->body = chunk;
 
-	/*
-	 * Read archiver stats struct
-	 */
-	if (fread(&myArchiverStats, 1, sizeof(myArchiverStats),
-			  fpin) != sizeof(myArchiverStats))
-	{
-		ereport(pgStatRunningInCollector ? LOG : WARNING,
-				(errmsg("corrupted statistics file \"%s\"", statfile)));
-		FreeFile(fpin);
-		return false;
-	}
-
-	/*
-	 * Read WAL stats struct
-	 */
-	if (fread(&myWalStats, 1, sizeof(myWalStats), fpin) != sizeof(myWalStats))
-	{
-		ereport(pgStatRunningInCollector ? LOG : WARNING,
-				(errmsg("corrupted statistics file \"%s\"", statfile)));
-		FreeFile(fpin);
-		return false;
-	}
-
-	/*
-	 * Read SLRU stats struct
-	 */
-	if (fread(mySLRUStats, 1, sizeof(mySLRUStats), fpin) != sizeof(mySLRUStats))
-	{
-		ereport(pgStatRunningInCollector ? LOG : WARNING,
-				(errmsg("corrupted statistics file \"%s\"", statfile)));
-		FreeFile(fpin);
-		return false;
-	}
-
-	/* By default, we're going to return the timestamp of the global file. */
-	*ts = myGlobalStats.stats_timestamp;
-
-	/*
-	 * We found an existing collector stats file.  Read it and look for a
-	 * record for the requested database.  If found, use its timestamp.
-	 */
-	for (;;)
-	{
-		switch (fgetc(fpin))
-		{
-				/*
-				 * 'D'	A PgStat_StatDBEntry struct describing a database
-				 * follows.
-				 */
-			case 'D':
-				if (fread(&dbentry, 1, offsetof(PgStat_StatDBEntry, tables),
-						  fpin) != offsetof(PgStat_StatDBEntry, tables))
-				{
-					ereport(pgStatRunningInCollector ? LOG : WARNING,
-							(errmsg("corrupted statistics file \"%s\"",
-									statfile)));
-					FreeFile(fpin);
-					return false;
-				}
-
-				/*
-				 * If this is the DB we're looking for, save its timestamp and
-				 * we're done.
-				 */
-				if (dbentry.databaseid == databaseid)
-				{
-					*ts = dbentry.stats_timestamp;
-					goto done;
-				}
-
-				break;
-
-				/*
-				 * 'R'	A PgStat_StatReplSlotEntry struct describing a
-				 * replication slot follows.
-				 */
-			case 'R':
-				if (fread(&myReplSlotStats, 1, sizeof(PgStat_StatReplSlotEntry), fpin)
-					!= sizeof(PgStat_StatReplSlotEntry))
-				{
-					ereport(pgStatRunningInCollector ? LOG : WARNING,
-							(errmsg("corrupted statistics file \"%s\"",
-									statfile)));
-					FreeFile(fpin);
-					return false;
-				}
-				break;
-
-				/*
-				 * 'S'	A PgStat_StatSubEntry struct describing subscription
-				 * statistics follows.
-				 */
-			case 'S':
-				if (fread(&mySubStats, 1, sizeof(PgStat_StatSubEntry), fpin)
-					!= sizeof(PgStat_StatSubEntry))
-				{
-					ereport(pgStatRunningInCollector ? LOG : WARNING,
-							(errmsg("corrupted statistics file \"%s\"",
-									statfile)));
-					FreeFile(fpin);
-					return false;
-				}
-				break;
-
-			case 'E':
-				goto done;
-
-			default:
-				{
-					ereport(pgStatRunningInCollector ? LOG : WARNING,
-							(errmsg("corrupted statistics file \"%s\"",
-									statfile)));
-					FreeFile(fpin);
-					return false;
-				}
-		}
-	}
-
-done:
-	FreeFile(fpin);
-	return true;
+	return shheader;
 }
 
 /*
- * If not already done, read the statistics collector stats file into
- * some hash tables.  The results will be kept until pgstat_clear_snapshot()
- * is called (typically, at end of transaction).
+ * Helper function for pgstat_shared_ref_get().
  */
-static void
-backend_read_statsfile(void)
+static bool
+pgstat_shared_ref_get_cached(PgStatHashKey key, PgStatSharedRef **shared_ref_p)
 {
-	TimestampTz min_ts = 0;
-	TimestampTz ref_ts = 0;
-	Oid			inquiry_db;
-	int			count;
+	bool found;
+	PgStatSharedRefHashEntry *cache_entry;
 
 	pgstat_assert_is_up();
 
-	/* already read it? */
-	if (pgStatDBHash)
-		return;
-	Assert(!pgStatRunningInCollector);
+	pgstat_setup_memcxt();
 
-	/*
-	 * In a normal backend, we check staleness of the data for our own DB, and
-	 * so we send MyDatabaseId in inquiry messages.  In the autovac launcher,
-	 * check staleness of the shared-catalog data, and send InvalidOid in
-	 * inquiry messages so as not to force writing unnecessary data.
-	 */
-	if (IsAutoVacuumLauncherProcess())
-		inquiry_db = InvalidOid;
-	else
-		inquiry_db = MyDatabaseId;
-
-	/*
-	 * Loop until fresh enough stats file is available or we ran out of time.
-	 * The stats inquiry message is sent repeatedly in case collector drops
-	 * it; but not every single time, as that just swamps the collector.
-	 */
-	for (count = 0; count < PGSTAT_POLL_LOOP_COUNT; count++)
+	if (!pgStatSharedRefHash)
 	{
-		bool		ok;
-		TimestampTz file_ts = 0;
-		TimestampTz cur_ts;
-
-		CHECK_FOR_INTERRUPTS();
-
-		ok = pgstat_read_db_statsfile_timestamp(inquiry_db, false, &file_ts);
-
-		cur_ts = GetCurrentTimestamp();
-		/* Calculate min acceptable timestamp, if we didn't already */
-		if (count == 0 || cur_ts < ref_ts)
-		{
-			/*
-			 * We set the minimum acceptable timestamp to PGSTAT_STAT_INTERVAL
-			 * msec before now.  This indirectly ensures that the collector
-			 * needn't write the file more often than PGSTAT_STAT_INTERVAL. In
-			 * an autovacuum worker, however, we want a lower delay to avoid
-			 * using stale data, so we use PGSTAT_RETRY_DELAY (since the
-			 * number of workers is low, this shouldn't be a problem).
-			 *
-			 * We don't recompute min_ts after sleeping, except in the
-			 * unlikely case that cur_ts went backwards.  So we might end up
-			 * accepting a file a bit older than PGSTAT_STAT_INTERVAL.  In
-			 * practice that shouldn't happen, though, as long as the sleep
-			 * time is less than PGSTAT_STAT_INTERVAL; and we don't want to
-			 * tell the collector that our cutoff time is less than what we'd
-			 * actually accept.
-			 */
-			ref_ts = cur_ts;
-			if (IsAutoVacuumWorkerProcess())
-				min_ts = TimestampTzPlusMilliseconds(ref_ts,
-													 -PGSTAT_RETRY_DELAY);
-			else
-				min_ts = TimestampTzPlusMilliseconds(ref_ts,
-													 -PGSTAT_STAT_INTERVAL);
-		}
-
-		/*
-		 * If the file timestamp is actually newer than cur_ts, we must have
-		 * had a clock glitch (system time went backwards) or there is clock
-		 * skew between our processor and the stats collector's processor.
-		 * Accept the file, but send an inquiry message anyway to make
-		 * pgstat_recv_inquiry do a sanity check on the collector's time.
-		 */
-		if (ok && file_ts > cur_ts)
-		{
-			/*
-			 * A small amount of clock skew between processors isn't terribly
-			 * surprising, but a large difference is worth logging.  We
-			 * arbitrarily define "large" as 1000 msec.
-			 */
-			if (file_ts >= TimestampTzPlusMilliseconds(cur_ts, 1000))
-			{
-				char	   *filetime;
-				char	   *mytime;
-
-				/* Copy because timestamptz_to_str returns a static buffer */
-				filetime = pstrdup(timestamptz_to_str(file_ts));
-				mytime = pstrdup(timestamptz_to_str(cur_ts));
-				ereport(LOG,
-						(errmsg("statistics collector's time %s is later than backend local time %s",
-								filetime, mytime)));
-				pfree(filetime);
-				pfree(mytime);
-			}
-
-			pgstat_send_inquiry(cur_ts, min_ts, inquiry_db);
-			break;
-		}
-
-		/* Normal acceptance case: file is not older than cutoff time */
-		if (ok && file_ts >= min_ts)
-			break;
-
-		/* Not there or too old, so kick the collector and wait a bit */
-		if ((count % PGSTAT_INQ_LOOP_COUNT) == 0)
-			pgstat_send_inquiry(cur_ts, min_ts, inquiry_db);
-
-		pg_usleep(PGSTAT_RETRY_DELAY * 1000L);
+		pgStatSharedRefHash =
+			pgstat_shared_ref_hash_create(pgStatSharedRefContext,
+										  PGSTAT_TABLE_HASH_SIZE, NULL);
+		pgStatSharedRefAge =
+			pg_atomic_read_u64(&pgStatShmem->gc_count);
 	}
 
-	if (count >= PGSTAT_POLL_LOOP_COUNT)
-		ereport(LOG,
-				(errmsg("using stale statistics instead of current ones "
-						"because stats collector is not responding")));
-
 	/*
-	 * Autovacuum launcher wants stats about all databases, but a shallow read
-	 * is sufficient.  Regular backends want a deep read for just the tables
-	 * they can see (MyDatabaseId + shared catalogs).
-	 */
-	if (IsAutoVacuumLauncherProcess())
-		pgStatDBHash = pgstat_read_statsfiles(InvalidOid, false, false);
-	else
-		pgStatDBHash = pgstat_read_statsfiles(MyDatabaseId, false, true);
-}
-
-
-/* ----------
- * pgstat_recv_inquiry() -
- *
- *	Process stat inquiry requests.
- * ----------
- */
-static void
-pgstat_recv_inquiry(PgStat_MsgInquiry *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-
-	elog(DEBUG2, "received inquiry for database %u", msg->databaseid);
-
-	/*
-	 * If there's already a write request for this DB, there's nothing to do.
+	 * pgStatSharedRefAge increments quite slowly than the time the
+	 * following loop takes so this is expected to iterate no more than
+	 * twice.
 	 *
-	 * Note that if a request is found, we return early and skip the below
-	 * check for clock skew.  This is okay, since the only way for a DB
-	 * request to be present in the list is that we have been here since the
-	 * last write round.  It seems sufficient to check for clock skew once per
-	 * write round.
+	 * XXX: Why is this a good place to do this?
 	 */
-	if (list_member_oid(pending_write_requests, msg->databaseid))
-		return;
+	while (pgstat_shared_refs_need_gc())
+		pgstat_shared_refs_gc();
 
 	/*
-	 * Check to see if we last wrote this database at a time >= the requested
-	 * cutoff time.  If so, this is a stale request that was generated before
-	 * we updated the DB file, and we don't need to do so again.
-	 *
-	 * If the requestor's local clock time is older than stats_timestamp, we
-	 * should suspect a clock glitch, ie system time going backwards; though
-	 * the more likely explanation is just delayed message receipt.  It is
-	 * worth expending a GetCurrentTimestamp call to be sure, since a large
-	 * retreat in the system clock reading could otherwise cause us to neglect
-	 * to update the stats file for a long time.
+	 * We immediately insert a cache entry, because it avoids 1) multiple
+	 * hashtable lookups in case of a cache miss 2) having to deal with
+	 * out-of-memory errors after incrementing
+	 * PgStatShm_StatEntryHeader->refcount.
 	 */
-	dbentry = pgstat_get_db_entry(msg->databaseid, false);
-	if (dbentry == NULL)
+
+	cache_entry = pgstat_shared_ref_hash_insert(pgStatSharedRefHash, key, &found);
+
+	if (!found || !cache_entry->shared_ref)
+	{
+		PgStatSharedRef *shared_ref;
+
+		cache_entry->shared_ref = shared_ref =
+			MemoryContextAlloc(pgStatSharedRefContext,
+							   sizeof(PgStatSharedRef));
+		shared_ref->shared_stats = NULL;
+		shared_ref->shared_entry = NULL;
+		shared_ref->pending = NULL;
+
+		found = false;
+	}
+	else if (cache_entry->shared_ref->shared_stats == NULL)
+	{
+		Assert(cache_entry->shared_ref->shared_entry == NULL);
+		found = false;
+	}
+	else
+	{
+		PgStatSharedRef *shared_ref PG_USED_FOR_ASSERTS_ONLY;
+
+		shared_ref = cache_entry->shared_ref;
+		Assert(shared_ref->shared_entry != NULL);
+		Assert(shared_ref->shared_stats != NULL);
+
+		Assert(shared_ref->shared_stats->magic == 0xdeadbeef);
+		/* should have at least our reference */
+		Assert(pg_atomic_read_u32(&shared_ref->shared_entry->refcount) > 0);
+	}
+
+	*shared_ref_p = cache_entry->shared_ref;
+	return found;
+}
+
+/*
+ * Get a shared stats reference. If create is true, the shared stats object is
+ * created if it does not exist.
+ */
+PgStatSharedRef *
+pgstat_shared_ref_get(PgStatKind type, Oid dboid, Oid objoid, bool create)
+{
+	PgStatHashKey key;
+	PgStatShmHashEntry *shhashent;
+	PgStatShm_StatEntryHeader *shheader = NULL;
+	PgStatSharedRef *shared_ref;
+	bool		shfound;
+
+	pgstat_assert_is_up();
+
+	key.kind = type;
+	key.dboid = dboid;
+	key.objoid = objoid;
+
+	Assert(pgStatSharedHash != NULL);
+	Assert(!pgStatShmem->is_shutdown);
+
+	/*
+	 * First check the lookup cache hashtable in local memory. If we find a
+	 * match here we can avoid taking locks / contention.
+	 */
+	if (pgstat_shared_ref_get_cached(key, &shared_ref))
+		return shared_ref;
+
+	Assert(shared_ref != NULL);
+
+	/*
+	 * Do a lookup in the hash table first - it's quite likely that the entry
+	 * already exists, and that way we only need a shared lock.
+	 */
+	shhashent = dshash_find(pgStatSharedHash, &key, false);
+
+	if (shhashent)
+		shfound = true;
+	else if (create)
 	{
 		/*
-		 * We have no data for this DB.  Enter a write request anyway so that
-		 * the global stats will get updated.  This is needed to prevent
-		 * backend_read_statsfile from waiting for data that we cannot supply,
-		 * in the case of a new DB that nobody has yet reported any stats for.
-		 * See the behavior of pgstat_read_db_statsfile_timestamp.
+		 * It's possible that somebody created the entry since the above
+		 * lookup, fall through to the same path as before if so.
 		 */
-	}
-	else if (msg->clock_time < dbentry->stats_timestamp)
-	{
-		TimestampTz cur_ts = GetCurrentTimestamp();
-
-		if (cur_ts < dbentry->stats_timestamp)
+		shhashent = dshash_find_or_insert(pgStatSharedHash, &key, &shfound);
+		if (!shfound)
 		{
 			/*
-			 * Sure enough, time went backwards.  Force a new stats file write
-			 * to get back in sync; but first, log a complaint.
+			 * Initialize refcount to 2, (1 marking it as valid, one for the
+			 * local reference). That prevents another backend from freeing
+			 * the entry once we release the lock below. The entry can't be
+			 * freed before the initialization because it can't be found as
+			 * long as we hold the dshash partition lock.
 			 */
-			char	   *writetime;
-			char	   *mytime;
+			shheader = pgstat_shared_stat_entry_init(type, shhashent, 2);
 
-			/* Copy because timestamptz_to_str returns a static buffer */
-			writetime = pstrdup(timestamptz_to_str(dbentry->stats_timestamp));
-			mytime = pstrdup(timestamptz_to_str(cur_ts));
-			ereport(LOG,
-					(errmsg("stats_timestamp %s is later than collector's time %s for database %u",
-							writetime, mytime, dbentry->databaseid)));
-			pfree(writetime);
-			pfree(mytime);
-		}
-		else
-		{
-			/*
-			 * Nope, it's just an old request.  Assuming msg's clock_time is
-			 * >= its cutoff_time, it must be stale, so we can ignore it.
-			 */
-			return;
+			dshash_release_lock(pgStatSharedHash, shhashent);
+
+			shared_ref->shared_stats = shheader;
+			shared_ref->shared_entry = shhashent;
 		}
 	}
-	else if (msg->cutoff_time <= dbentry->stats_timestamp)
+	else
 	{
-		/* Stale request, ignore it */
-		return;
-	}
-
-	/*
-	 * We need to write this DB, so create a request.
-	 */
-	pending_write_requests = lappend_oid(pending_write_requests,
-										 msg->databaseid);
-}
-
-
-/* ----------
- * pgstat_recv_tabstat() -
- *
- *	Count what the backend has done.
- * ----------
- */
-static void
-pgstat_recv_tabstat(PgStat_MsgTabstat *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-	PgStat_StatTabEntry *tabentry;
-	int			i;
-	bool		found;
-
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-
-	/*
-	 * Update database-wide stats.
-	 */
-	dbentry->n_xact_commit += (PgStat_Counter) (msg->m_xact_commit);
-	dbentry->n_xact_rollback += (PgStat_Counter) (msg->m_xact_rollback);
-	dbentry->n_block_read_time += msg->m_block_read_time;
-	dbentry->n_block_write_time += msg->m_block_write_time;
-
-	dbentry->total_session_time += msg->m_session_time;
-	dbentry->total_active_time += msg->m_active_time;
-	dbentry->total_idle_in_xact_time += msg->m_idle_in_xact_time;
-
-	/*
-	 * Process all table entries in the message.
-	 */
-	for (i = 0; i < msg->m_nentries; i++)
-	{
-		PgStat_TableEntry *tabmsg = &(msg->m_entry[i]);
-
-		tabentry = (PgStat_StatTabEntry *) hash_search(dbentry->tables,
-													   (void *) &(tabmsg->t_id),
-													   HASH_ENTER, &found);
-
-		if (!found)
-		{
-			/*
-			 * If it's a new table entry, initialize counters to the values we
-			 * just got.
-			 */
-			tabentry->numscans = tabmsg->t_counts.t_numscans;
-			tabentry->tuples_returned = tabmsg->t_counts.t_tuples_returned;
-			tabentry->tuples_fetched = tabmsg->t_counts.t_tuples_fetched;
-			tabentry->tuples_inserted = tabmsg->t_counts.t_tuples_inserted;
-			tabentry->tuples_updated = tabmsg->t_counts.t_tuples_updated;
-			tabentry->tuples_deleted = tabmsg->t_counts.t_tuples_deleted;
-			tabentry->tuples_hot_updated = tabmsg->t_counts.t_tuples_hot_updated;
-			tabentry->n_live_tuples = tabmsg->t_counts.t_delta_live_tuples;
-			tabentry->n_dead_tuples = tabmsg->t_counts.t_delta_dead_tuples;
-			tabentry->changes_since_analyze = tabmsg->t_counts.t_changed_tuples;
-			tabentry->inserts_since_vacuum = tabmsg->t_counts.t_tuples_inserted;
-			tabentry->blocks_fetched = tabmsg->t_counts.t_blocks_fetched;
-			tabentry->blocks_hit = tabmsg->t_counts.t_blocks_hit;
-
-			tabentry->vacuum_timestamp = 0;
-			tabentry->vacuum_count = 0;
-			tabentry->autovac_vacuum_timestamp = 0;
-			tabentry->autovac_vacuum_count = 0;
-			tabentry->analyze_timestamp = 0;
-			tabentry->analyze_count = 0;
-			tabentry->autovac_analyze_timestamp = 0;
-			tabentry->autovac_analyze_count = 0;
-		}
-		else
-		{
-			/*
-			 * Otherwise add the values to the existing entry.
-			 */
-			tabentry->numscans += tabmsg->t_counts.t_numscans;
-			tabentry->tuples_returned += tabmsg->t_counts.t_tuples_returned;
-			tabentry->tuples_fetched += tabmsg->t_counts.t_tuples_fetched;
-			tabentry->tuples_inserted += tabmsg->t_counts.t_tuples_inserted;
-			tabentry->tuples_updated += tabmsg->t_counts.t_tuples_updated;
-			tabentry->tuples_deleted += tabmsg->t_counts.t_tuples_deleted;
-			tabentry->tuples_hot_updated += tabmsg->t_counts.t_tuples_hot_updated;
-			/*
-			 * If table was truncated/dropped, first reset the live/dead
-			 * counters.
-			 */
-			if (tabmsg->t_counts.t_truncdropped)
-			{
-				tabentry->n_live_tuples = 0;
-				tabentry->n_dead_tuples = 0;
-				tabentry->inserts_since_vacuum = 0;
-			}
-			tabentry->n_live_tuples += tabmsg->t_counts.t_delta_live_tuples;
-			tabentry->n_dead_tuples += tabmsg->t_counts.t_delta_dead_tuples;
-			tabentry->changes_since_analyze += tabmsg->t_counts.t_changed_tuples;
-			tabentry->inserts_since_vacuum += tabmsg->t_counts.t_tuples_inserted;
-			tabentry->blocks_fetched += tabmsg->t_counts.t_blocks_fetched;
-			tabentry->blocks_hit += tabmsg->t_counts.t_blocks_hit;
-		}
-
-		/* Clamp n_live_tuples in case of negative delta_live_tuples */
-		tabentry->n_live_tuples = Max(tabentry->n_live_tuples, 0);
-		/* Likewise for n_dead_tuples */
-		tabentry->n_dead_tuples = Max(tabentry->n_dead_tuples, 0);
+		shfound = false;
 
 		/*
-		 * Add per-table stats to the per-database entry, too.
+		 * If we're not creating, delete the reference again. In all
+		 * likelihood it's just a stats lookup - no point wasting memory for a
+		 * shared ref to nothing...
 		 */
-		dbentry->n_tuples_returned += tabmsg->t_counts.t_tuples_returned;
-		dbentry->n_tuples_fetched += tabmsg->t_counts.t_tuples_fetched;
-		dbentry->n_tuples_inserted += tabmsg->t_counts.t_tuples_inserted;
-		dbentry->n_tuples_updated += tabmsg->t_counts.t_tuples_updated;
-		dbentry->n_tuples_deleted += tabmsg->t_counts.t_tuples_deleted;
-		dbentry->n_blocks_fetched += tabmsg->t_counts.t_blocks_fetched;
-		dbentry->n_blocks_hit += tabmsg->t_counts.t_blocks_hit;
-	}
-}
+		pgstat_shared_ref_release(key, shared_ref);
 
-
-/* ----------
- * pgstat_recv_tabpurge() -
- *
- *	Arrange for dead table removal.
- * ----------
- */
-static void
-pgstat_recv_tabpurge(PgStat_MsgTabpurge *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-	int			i;
-
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, false);
-
-	/*
-	 * No need to purge if we don't even know the database.
-	 */
-	if (!dbentry || !dbentry->tables)
-		return;
-
-	/*
-	 * Process all table entries in the message.
-	 */
-	for (i = 0; i < msg->m_nentries; i++)
-	{
-		/* Remove from hashtable if present; we don't care if it's not. */
-		(void) hash_search(dbentry->tables,
-						   (void *) &(msg->m_tableid[i]),
-						   HASH_REMOVE, NULL);
-	}
-}
-
-
-/* ----------
- * pgstat_recv_dropdb() -
- *
- *	Arrange for dead database removal
- * ----------
- */
-static void
-pgstat_recv_dropdb(PgStat_MsgDropdb *msg, int len)
-{
-	Oid			dbid = msg->m_databaseid;
-	PgStat_StatDBEntry *dbentry;
-
-	/*
-	 * Lookup the database in the hashtable.
-	 */
-	dbentry = pgstat_get_db_entry(dbid, false);
-
-	/*
-	 * If found, remove it (along with the db statfile).
-	 */
-	if (dbentry)
-	{
-		char		statfile[MAXPGPATH];
-
-		get_dbstat_filename(false, false, dbid, statfile, MAXPGPATH);
-
-		elog(DEBUG2, "removing stats file \"%s\"", statfile);
-		unlink(statfile);
-
-		if (dbentry->tables != NULL)
-			hash_destroy(dbentry->tables);
-		if (dbentry->functions != NULL)
-			hash_destroy(dbentry->functions);
-
-		if (hash_search(pgStatDBHash,
-						(void *) &dbid,
-						HASH_REMOVE, NULL) == NULL)
-			ereport(ERROR,
-					(errmsg("database hash table corrupted during cleanup --- abort")));
-	}
-}
-
-
-/* ----------
- * pgstat_recv_resetcounter() -
- *
- *	Reset the statistics for the specified database.
- * ----------
- */
-static void
-pgstat_recv_resetcounter(PgStat_MsgResetcounter *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-
-	/*
-	 * Lookup the database in the hashtable.  Nothing to do if not there.
-	 */
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, false);
-
-	if (!dbentry)
-		return;
-
-	/*
-	 * We simply throw away all the database's table entries by recreating a
-	 * new hash table for them.
-	 */
-	if (dbentry->tables != NULL)
-		hash_destroy(dbentry->tables);
-	if (dbentry->functions != NULL)
-		hash_destroy(dbentry->functions);
-
-	dbentry->tables = NULL;
-	dbentry->functions = NULL;
-
-	/*
-	 * Reset database-level stats, too.  This creates empty hash tables for
-	 * tables and functions.
-	 */
-	reset_dbentry_counters(dbentry);
-}
-
-/* ----------
- * pgstat_recv_resetsharedcounter() -
- *
- *	Reset some shared statistics of the cluster.
- * ----------
- */
-static void
-pgstat_recv_resetsharedcounter(PgStat_MsgResetsharedcounter *msg, int len)
-{
-	if (msg->m_resettarget == RESET_BGWRITER)
-	{
-		/* Reset the global, bgwriter and checkpointer statistics for the cluster. */
-		memset(&globalStats, 0, sizeof(globalStats));
-		globalStats.bgwriter.stat_reset_timestamp = GetCurrentTimestamp();
-	}
-	else if (msg->m_resettarget == RESET_ARCHIVER)
-	{
-		/* Reset the archiver statistics for the cluster. */
-		memset(&archiverStats, 0, sizeof(archiverStats));
-		archiverStats.stat_reset_timestamp = GetCurrentTimestamp();
-	}
-	else if (msg->m_resettarget == RESET_WAL)
-	{
-		/* Reset the WAL statistics for the cluster. */
-		memset(&walStats, 0, sizeof(walStats));
-		walStats.stat_reset_timestamp = GetCurrentTimestamp();
-	}
-
-	/*
-	 * Presumably the sender of this message validated the target, don't
-	 * complain here if it's not valid
-	 */
-}
-
-/* ----------
- * pgstat_recv_resetsinglecounter() -
- *
- *	Reset a statistics for a single object, which may be of current
- *	database or shared across all databases in the cluster.
- * ----------
- */
-static void
-pgstat_recv_resetsinglecounter(PgStat_MsgResetsinglecounter *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-
-	if (IsSharedRelation(msg->m_objectid))
-		dbentry = pgstat_get_db_entry(InvalidOid, false);
-	else
-		dbentry = pgstat_get_db_entry(msg->m_databaseid, false);
-
-	if (!dbentry)
-		return;
-
-	/* Set the reset timestamp for the whole database */
-	dbentry->stat_reset_timestamp = GetCurrentTimestamp();
-
-	/* Remove object if it exists, ignore it if not */
-	if (msg->m_resettype == RESET_TABLE)
-		(void) hash_search(dbentry->tables, (void *) &(msg->m_objectid),
-						   HASH_REMOVE, NULL);
-	else if (msg->m_resettype == RESET_FUNCTION)
-		(void) hash_search(dbentry->functions, (void *) &(msg->m_objectid),
-						   HASH_REMOVE, NULL);
-}
-
-/* ----------
- * pgstat_recv_resetslrucounter() -
- *
- *	Reset some SLRU statistics of the cluster.
- * ----------
- */
-static void
-pgstat_recv_resetslrucounter(PgStat_MsgResetslrucounter *msg, int len)
-{
-	int			i;
-	TimestampTz ts = GetCurrentTimestamp();
-
-	for (i = 0; i < SLRU_NUM_ELEMENTS; i++)
-	{
-		/* reset entry with the given index, or all entries (index is -1) */
-		if ((msg->m_index == -1) || (msg->m_index == i))
-		{
-			memset(&slruStats[i], 0, sizeof(slruStats[i]));
-			slruStats[i].stat_reset_timestamp = ts;
-		}
-	}
-}
-
-/* ----------
- * pgstat_recv_resetreplslotcounter() -
- *
- *	Reset some replication slot statistics of the cluster.
- * ----------
- */
-static void
-pgstat_recv_resetreplslotcounter(PgStat_MsgResetreplslotcounter *msg,
-								 int len)
-{
-	PgStat_StatReplSlotEntry *slotent;
-	TimestampTz ts;
-
-	/* Return if we don't have replication slot statistics */
-	if (replSlotStatHash == NULL)
-		return;
-
-	ts = GetCurrentTimestamp();
-	if (msg->clearall)
-	{
-		HASH_SEQ_STATUS sstat;
-
-		hash_seq_init(&sstat, replSlotStatHash);
-		while ((slotent = (PgStat_StatReplSlotEntry *) hash_seq_search(&sstat)) != NULL)
-			pgstat_reset_replslot(slotent, ts);
-	}
-	else
-	{
-		/* Get the slot statistics to reset */
-		slotent = pgstat_get_replslot_entry(msg->m_slotname, false);
-
-		/*
-		 * Nothing to do if the given slot entry is not found.  This could
-		 * happen when the slot with the given name is removed and the
-		 * corresponding statistics entry is also removed before receiving the
-		 * reset message.
-		 */
-		if (!slotent)
-			return;
-
-		/* Reset the stats for the requested replication slot */
-		pgstat_reset_replslot(slotent, ts);
-	}
-}
-
-/* ----------
- * pgstat_recv_resetsubcounter() -
- *
- *	Reset some subscription statistics of the cluster.
- * ----------
- */
-static void
-pgstat_recv_resetsubcounter(PgStat_MsgResetsubcounter *msg, int len)
-{
-	PgStat_StatSubEntry *subentry;
-	TimestampTz ts;
-
-	/* Return if we don't have replication subscription statistics */
-	if (subscriptionStatHash == NULL)
-		return;
-
-	ts = GetCurrentTimestamp();
-	if (!OidIsValid(msg->m_subid))
-	{
-		HASH_SEQ_STATUS sstat;
-
-		/* Clear all subscription counters */
-		hash_seq_init(&sstat, subscriptionStatHash);
-		while ((subentry = (PgStat_StatSubEntry *) hash_seq_search(&sstat)) != NULL)
-			pgstat_reset_subscription(subentry, ts);
-	}
-	else
-	{
-		/* Get the subscription statistics to reset */
-		subentry = pgstat_get_subscription_entry(msg->m_subid, false);
-
-		/*
-		 * Nothing to do if the given subscription entry is not found.  This
-		 * could happen when the subscription with the subid is removed and
-		 * the corresponding statistics entry is also removed before receiving
-		 * the reset message.
-		 */
-		if (!subentry)
-			return;
-
-		/* Reset the stats for the requested subscription */
-		pgstat_reset_subscription(subentry, ts);
-	}
-}
-
-
-/* ----------
- * pgstat_recv_autovac() -
- *
- *	Process an autovacuum signaling message.
- * ----------
- */
-static void
-pgstat_recv_autovac(PgStat_MsgAutovacStart *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-
-	/*
-	 * Store the last autovacuum time in the database's hashtable entry.
-	 */
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-
-	dbentry->last_autovac_time = msg->m_start_time;
-}
-
-/* ----------
- * pgstat_recv_vacuum() -
- *
- *	Process a VACUUM message.
- * ----------
- */
-static void
-pgstat_recv_vacuum(PgStat_MsgVacuum *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-	PgStat_StatTabEntry *tabentry;
-
-	/*
-	 * Store the data in the table's hashtable entry.
-	 */
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-
-	tabentry = pgstat_get_tab_entry(dbentry, msg->m_tableoid, true);
-
-	tabentry->n_live_tuples = msg->m_live_tuples;
-	tabentry->n_dead_tuples = msg->m_dead_tuples;
-
-	/*
-	 * It is quite possible that a non-aggressive VACUUM ended up skipping
-	 * various pages, however, we'll zero the insert counter here regardless.
-	 * It's currently used only to track when we need to perform an "insert"
-	 * autovacuum, which are mainly intended to freeze newly inserted tuples.
-	 * Zeroing this may just mean we'll not try to vacuum the table again
-	 * until enough tuples have been inserted to trigger another insert
-	 * autovacuum.  An anti-wraparound autovacuum will catch any persistent
-	 * stragglers.
-	 */
-	tabentry->inserts_since_vacuum = 0;
-
-	if (msg->m_autovacuum)
-	{
-		tabentry->autovac_vacuum_timestamp = msg->m_vacuumtime;
-		tabentry->autovac_vacuum_count++;
-	}
-	else
-	{
-		tabentry->vacuum_timestamp = msg->m_vacuumtime;
-		tabentry->vacuum_count++;
-	}
-}
-
-/* ----------
- * pgstat_recv_analyze() -
- *
- *	Process an ANALYZE message.
- * ----------
- */
-static void
-pgstat_recv_analyze(PgStat_MsgAnalyze *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-	PgStat_StatTabEntry *tabentry;
-
-	/*
-	 * Store the data in the table's hashtable entry.
-	 */
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-
-	tabentry = pgstat_get_tab_entry(dbentry, msg->m_tableoid, true);
-
-	tabentry->n_live_tuples = msg->m_live_tuples;
-	tabentry->n_dead_tuples = msg->m_dead_tuples;
-
-	/*
-	 * If commanded, reset changes_since_analyze to zero.  This forgets any
-	 * changes that were committed while the ANALYZE was in progress, but we
-	 * have no good way to estimate how many of those there were.
-	 */
-	if (msg->m_resetcounter)
-		tabentry->changes_since_analyze = 0;
-
-	if (msg->m_autovacuum)
-	{
-		tabentry->autovac_analyze_timestamp = msg->m_analyzetime;
-		tabentry->autovac_analyze_count++;
-	}
-	else
-	{
-		tabentry->analyze_timestamp = msg->m_analyzetime;
-		tabentry->analyze_count++;
-	}
-}
-
-
-/* ----------
- * pgstat_recv_archiver() -
- *
- *	Process a ARCHIVER message.
- * ----------
- */
-static void
-pgstat_recv_archiver(PgStat_MsgArchiver *msg, int len)
-{
-	if (msg->m_failed)
-	{
-		/* Failed archival attempt */
-		++archiverStats.failed_count;
-		memcpy(archiverStats.last_failed_wal, msg->m_xlog,
-			   sizeof(archiverStats.last_failed_wal));
-		archiverStats.last_failed_timestamp = msg->m_timestamp;
-	}
-	else
-	{
-		/* Successful archival operation */
-		++archiverStats.archived_count;
-		memcpy(archiverStats.last_archived_wal, msg->m_xlog,
-			   sizeof(archiverStats.last_archived_wal));
-		archiverStats.last_archived_timestamp = msg->m_timestamp;
-	}
-}
-
-/* ----------
- * pgstat_recv_bgwriter() -
- *
- *	Process a BGWRITER message.
- * ----------
- */
-static void
-pgstat_recv_bgwriter(PgStat_MsgBgWriter *msg, int len)
-{
-	globalStats.bgwriter.buf_written_clean += msg->m_buf_written_clean;
-	globalStats.bgwriter.maxwritten_clean += msg->m_maxwritten_clean;
-	globalStats.bgwriter.buf_alloc += msg->m_buf_alloc;
-}
-
-/* ----------
- * pgstat_recv_checkpointer() -
- *
- *	Process a CHECKPOINTER message.
- * ----------
- */
-static void
-pgstat_recv_checkpointer(PgStat_MsgCheckpointer *msg, int len)
-{
-	globalStats.checkpointer.timed_checkpoints += msg->m_timed_checkpoints;
-	globalStats.checkpointer.requested_checkpoints += msg->m_requested_checkpoints;
-	globalStats.checkpointer.checkpoint_write_time += msg->m_checkpoint_write_time;
-	globalStats.checkpointer.checkpoint_sync_time += msg->m_checkpoint_sync_time;
-	globalStats.checkpointer.buf_written_checkpoints += msg->m_buf_written_checkpoints;
-	globalStats.checkpointer.buf_written_backend += msg->m_buf_written_backend;
-	globalStats.checkpointer.buf_fsync_backend += msg->m_buf_fsync_backend;
-}
-
-/* ----------
- * pgstat_recv_wal() -
- *
- *	Process a WAL message.
- * ----------
- */
-static void
-pgstat_recv_wal(PgStat_MsgWal *msg, int len)
-{
-	walStats.wal_records += msg->m_wal_records;
-	walStats.wal_fpi += msg->m_wal_fpi;
-	walStats.wal_bytes += msg->m_wal_bytes;
-	walStats.wal_buffers_full += msg->m_wal_buffers_full;
-	walStats.wal_write += msg->m_wal_write;
-	walStats.wal_sync += msg->m_wal_sync;
-	walStats.wal_write_time += msg->m_wal_write_time;
-	walStats.wal_sync_time += msg->m_wal_sync_time;
-}
-
-/* ----------
- * pgstat_recv_slru() -
- *
- *	Process a SLRU message.
- * ----------
- */
-static void
-pgstat_recv_slru(PgStat_MsgSLRU *msg, int len)
-{
-	slruStats[msg->m_index].blocks_zeroed += msg->m_blocks_zeroed;
-	slruStats[msg->m_index].blocks_hit += msg->m_blocks_hit;
-	slruStats[msg->m_index].blocks_read += msg->m_blocks_read;
-	slruStats[msg->m_index].blocks_written += msg->m_blocks_written;
-	slruStats[msg->m_index].blocks_exists += msg->m_blocks_exists;
-	slruStats[msg->m_index].flush += msg->m_flush;
-	slruStats[msg->m_index].truncate += msg->m_truncate;
-}
-
-/* ----------
- * pgstat_recv_recoveryconflict() -
- *
- *	Process a RECOVERYCONFLICT message.
- * ----------
- */
-static void
-pgstat_recv_recoveryconflict(PgStat_MsgRecoveryConflict *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-
-	switch (msg->m_reason)
-	{
-		case PROCSIG_RECOVERY_CONFLICT_DATABASE:
-
-			/*
-			 * Since we drop the information about the database as soon as it
-			 * replicates, there is no point in counting these conflicts.
-			 */
-			break;
-		case PROCSIG_RECOVERY_CONFLICT_TABLESPACE:
-			dbentry->n_conflict_tablespace++;
-			break;
-		case PROCSIG_RECOVERY_CONFLICT_LOCK:
-			dbentry->n_conflict_lock++;
-			break;
-		case PROCSIG_RECOVERY_CONFLICT_SNAPSHOT:
-			dbentry->n_conflict_snapshot++;
-			break;
-		case PROCSIG_RECOVERY_CONFLICT_BUFFERPIN:
-			dbentry->n_conflict_bufferpin++;
-			break;
-		case PROCSIG_RECOVERY_CONFLICT_STARTUP_DEADLOCK:
-			dbentry->n_conflict_startup_deadlock++;
-			break;
-	}
-}
-
-/* ----------
- * pgstat_recv_deadlock() -
- *
- *	Process a DEADLOCK message.
- * ----------
- */
-static void
-pgstat_recv_deadlock(PgStat_MsgDeadlock *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-
-	dbentry->n_deadlocks++;
-}
-
-/* ----------
- * pgstat_recv_checksum_failure() -
- *
- *	Process a CHECKSUMFAILURE message.
- * ----------
- */
-static void
-pgstat_recv_checksum_failure(PgStat_MsgChecksumFailure *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-
-	dbentry->n_checksum_failures += msg->m_failurecount;
-	dbentry->last_checksum_failure = msg->m_failure_time;
-}
-
-/* ----------
- * pgstat_recv_replslot() -
- *
- *	Process a REPLSLOT message.
- * ----------
- */
-static void
-pgstat_recv_replslot(PgStat_MsgReplSlot *msg, int len)
-{
-	if (msg->m_drop)
-	{
-		Assert(!msg->m_create);
-
-		/* Remove the replication slot statistics with the given name */
-		if (replSlotStatHash != NULL)
-			(void) hash_search(replSlotStatHash,
-							   (void *) &(msg->m_slotname),
-							   HASH_REMOVE,
-							   NULL);
-	}
-	else
-	{
-		PgStat_StatReplSlotEntry *slotent;
-
-		slotent = pgstat_get_replslot_entry(msg->m_slotname, true);
-		Assert(slotent);
-
-		if (msg->m_create)
-		{
-			/*
-			 * If the message for dropping the slot with the same name gets
-			 * lost, slotent has stats for the old slot. So we initialize all
-			 * counters at slot creation.
-			 */
-			pgstat_reset_replslot(slotent, 0);
-		}
-		else
-		{
-			/* Update the replication slot statistics */
-			slotent->spill_txns += msg->m_spill_txns;
-			slotent->spill_count += msg->m_spill_count;
-			slotent->spill_bytes += msg->m_spill_bytes;
-			slotent->stream_txns += msg->m_stream_txns;
-			slotent->stream_count += msg->m_stream_count;
-			slotent->stream_bytes += msg->m_stream_bytes;
-			slotent->total_txns += msg->m_total_txns;
-			slotent->total_bytes += msg->m_total_bytes;
-		}
-	}
-}
-
-/* ----------
- * pgstat_recv_connect() -
- *
- *	Process a CONNECT message.
- * ----------
- */
-static void
-pgstat_recv_connect(PgStat_MsgConnect *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-	dbentry->n_sessions++;
-}
-
-/* ----------
- * pgstat_recv_disconnect() -
- *
- *	Process a DISCONNECT message.
- * ----------
- */
-static void
-pgstat_recv_disconnect(PgStat_MsgDisconnect *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-
-	switch (msg->m_cause)
-	{
-		case DISCONNECT_NOT_YET:
-		case DISCONNECT_NORMAL:
-			/* we don't collect these */
-			break;
-		case DISCONNECT_CLIENT_EOF:
-			dbentry->n_sessions_abandoned++;
-			break;
-		case DISCONNECT_FATAL:
-			dbentry->n_sessions_fatal++;
-			break;
-		case DISCONNECT_KILLED:
-			dbentry->n_sessions_killed++;
-			break;
-	}
-}
-
-/* ----------
- * pgstat_recv_tempfile() -
- *
- *	Process a TEMPFILE message.
- * ----------
- */
-static void
-pgstat_recv_tempfile(PgStat_MsgTempFile *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-
-	dbentry->n_temp_bytes += msg->m_filesize;
-	dbentry->n_temp_files += 1;
-}
-
-/* ----------
- * pgstat_recv_funcstat() -
- *
- *	Count what the backend has done.
- * ----------
- */
-static void
-pgstat_recv_funcstat(PgStat_MsgFuncstat *msg, int len)
-{
-	PgStat_FunctionEntry *funcmsg = &(msg->m_entry[0]);
-	PgStat_StatDBEntry *dbentry;
-	PgStat_StatFuncEntry *funcentry;
-	int			i;
-	bool		found;
-
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, true);
-
-	/*
-	 * Process all function entries in the message.
-	 */
-	for (i = 0; i < msg->m_nentries; i++, funcmsg++)
-	{
-		funcentry = (PgStat_StatFuncEntry *) hash_search(dbentry->functions,
-														 (void *) &(funcmsg->f_id),
-														 HASH_ENTER, &found);
-
-		if (!found)
-		{
-			/*
-			 * If it's a new function entry, initialize counters to the values
-			 * we just got.
-			 */
-			funcentry->f_numcalls = funcmsg->f_numcalls;
-			funcentry->f_total_time = funcmsg->f_total_time;
-			funcentry->f_self_time = funcmsg->f_self_time;
-		}
-		else
-		{
-			/*
-			 * Otherwise add the values to the existing entry.
-			 */
-			funcentry->f_numcalls += funcmsg->f_numcalls;
-			funcentry->f_total_time += funcmsg->f_total_time;
-			funcentry->f_self_time += funcmsg->f_self_time;
-		}
-	}
-}
-
-/* ----------
- * pgstat_recv_funcpurge() -
- *
- *	Arrange for dead function removal.
- * ----------
- */
-static void
-pgstat_recv_funcpurge(PgStat_MsgFuncpurge *msg, int len)
-{
-	PgStat_StatDBEntry *dbentry;
-	int			i;
-
-	dbentry = pgstat_get_db_entry(msg->m_databaseid, false);
-
-	/*
-	 * No need to purge if we don't even know the database.
-	 */
-	if (!dbentry || !dbentry->functions)
-		return;
-
-	/*
-	 * Process all function entries in the message.
-	 */
-	for (i = 0; i < msg->m_nentries; i++)
-	{
-		/* Remove from hashtable if present; we don't care if it's not. */
-		(void) hash_search(dbentry->functions,
-						   (void *) &(msg->m_functionid[i]),
-						   HASH_REMOVE, NULL);
-	}
-}
-
-/* ----------
- * pgstat_recv_subscription_drop() -
- *
- *	Process a SUBSCRIPTIONDROP message.
- * ----------
- */
-static void
-pgstat_recv_subscription_drop(PgStat_MsgSubscriptionDrop *msg, int len)
-{
-	/* Return if we don't have replication subscription statistics */
-	if (subscriptionStatHash == NULL)
-		return;
-
-	/* Remove from hashtable if present; we don't care if it's not */
-	(void) hash_search(subscriptionStatHash, (void *) &(msg->m_subid),
-					   HASH_REMOVE, NULL);
-}
-
-/* ----------
- * pgstat_recv_subscription_error() -
- *
- *	Process a SUBSCRIPTIONERROR message.
- * ----------
- */
-static void
-pgstat_recv_subscription_error(PgStat_MsgSubscriptionError *msg, int len)
-{
-	PgStat_StatSubEntry *subentry;
-
-	/* Get the subscription stats */
-	subentry = pgstat_get_subscription_entry(msg->m_subid, true);
-	Assert(subentry);
-
-	if (msg->m_is_apply_error)
-		subentry->apply_error_count++;
-	else
-		subentry->sync_error_count++;
-}
-
-/* ----------
- * pgstat_write_statsfile_needed() -
- *
- *	Do we need to write out any stats files?
- * ----------
- */
-static bool
-pgstat_write_statsfile_needed(void)
-{
-	if (pending_write_requests != NIL)
-		return true;
-
-	/* Everything was written recently */
-	return false;
-}
-
-/* ----------
- * pgstat_db_requested() -
- *
- *	Checks whether stats for a particular DB need to be written to a file.
- * ----------
- */
-static bool
-pgstat_db_requested(Oid databaseid)
-{
-	/*
-	 * If any requests are outstanding at all, we should write the stats for
-	 * shared catalogs (the "database" with OID 0).  This ensures that
-	 * backends will see up-to-date stats for shared catalogs, even though
-	 * they send inquiry messages mentioning only their own DB.
-	 */
-	if (databaseid == InvalidOid && pending_write_requests != NIL)
-		return true;
-
-	/* Search to see if there's an open request to write this database. */
-	if (list_member_oid(pending_write_requests, databaseid))
-		return true;
-
-	return false;
-}
-
-/* ----------
- * pgstat_replslot_entry
- *
- * Return the entry of replication slot stats with the given name. Return
- * NULL if not found and the caller didn't request to create it.
- *
- * create tells whether to create the new slot entry if it is not found.
- * ----------
- */
-static PgStat_StatReplSlotEntry *
-pgstat_get_replslot_entry(NameData name, bool create)
-{
-	PgStat_StatReplSlotEntry *slotent;
-	bool		found;
-
-	if (replSlotStatHash == NULL)
-	{
-		HASHCTL		hash_ctl;
-
-		/*
-		 * Quick return NULL if the hash table is empty and the caller didn't
-		 * request to create the entry.
-		 */
-		if (!create)
-			return NULL;
-
-		hash_ctl.keysize = sizeof(NameData);
-		hash_ctl.entrysize = sizeof(PgStat_StatReplSlotEntry);
-		replSlotStatHash = hash_create("Replication slots hash",
-									   PGSTAT_REPLSLOT_HASH_SIZE,
-									   &hash_ctl,
-									   HASH_ELEM | HASH_BLOBS);
-	}
-
-	slotent = (PgStat_StatReplSlotEntry *) hash_search(replSlotStatHash,
-													   (void *) &name,
-													   create ? HASH_ENTER : HASH_FIND,
-													   &found);
-
-	if (!slotent)
-	{
-		/* not found */
-		Assert(!create && !found);
 		return NULL;
 	}
 
-	/* initialize the entry */
-	if (create && !found)
+	if (shfound)
 	{
-		namestrcpy(&(slotent->slotname), NameStr(name));
-		pgstat_reset_replslot(slotent, 0);
+		shheader = dsa_get_address(pgStatDSA, shhashent->body);
+
+		Assert(shheader->magic == 0xdeadbeef);
+		Assert(shhashent->dropped || pg_atomic_read_u32(&shhashent->refcount) > 0);
+
+		pg_atomic_fetch_add_u32(&shhashent->refcount, 1);
+
+		dshash_release_lock(pgStatSharedHash, shhashent);
+
+		shared_ref->shared_stats = shheader;
+		shared_ref->shared_entry = shhashent;
 	}
 
-	return slotent;
+	return shared_ref;
 }
 
-/* ----------
- * pgstat_reset_replslot
- *
- * Reset the given replication slot stats.
- * ----------
- */
 static void
-pgstat_reset_replslot(PgStat_StatReplSlotEntry *slotent, TimestampTz ts)
+pgstat_shared_ref_release(PgStatHashKey key, PgStatSharedRef *shared_ref)
 {
-	/* reset only counters. Don't clear slot name */
-	slotent->spill_txns = 0;
-	slotent->spill_count = 0;
-	slotent->spill_bytes = 0;
-	slotent->stream_txns = 0;
-	slotent->stream_count = 0;
-	slotent->stream_bytes = 0;
-	slotent->total_txns = 0;
-	slotent->total_bytes = 0;
-	slotent->stat_reset_timestamp = ts;
-}
+	Assert(shared_ref == NULL || shared_ref->pending == NULL);
 
-/* ----------
- * pgstat_get_subscription_entry
- *
- * Return the subscription statistics entry with the given subscription OID.
- * If no subscription entry exists, initialize it, if the create parameter is
- * true.  Else, return NULL.
- * ----------
- */
-static PgStat_StatSubEntry *
-pgstat_get_subscription_entry(Oid subid, bool create)
-{
-	PgStat_StatSubEntry *subentry;
-	bool		found;
-	HASHACTION	action = (create ? HASH_ENTER : HASH_FIND);
-
-	if (subscriptionStatHash == NULL)
+	if (shared_ref && shared_ref->shared_stats)
 	{
-		HASHCTL		hash_ctl;
+		Assert(shared_ref->shared_stats->magic == 0xdeadbeef);
+		Assert(shared_ref->pending == NULL);
 
 		/*
-		 * Quick return NULL if the hash table is empty and the caller didn't
-		 * request to create the entry.
+		 * AFIXME: this probably is racy. Another backend could look up the
+		 * stat, bump the refcount, as we free it.
 		 */
-		if (!create)
-			return NULL;
+		if (pg_atomic_fetch_sub_u32(&shared_ref->shared_entry->refcount, 1) == 1)
+		{
+			PgStatShmHashEntry *shent;
+			dsa_pointer dsap;
 
-		hash_ctl.keysize = sizeof(Oid);
-		hash_ctl.entrysize = sizeof(PgStat_StatSubEntry);
-		subscriptionStatHash = hash_create("Subscription hash",
-										   PGSTAT_SUBSCRIPTION_HASH_SIZE,
-										   &hash_ctl,
-										   HASH_ELEM | HASH_BLOBS);
+			/*
+			 * We're the last referrer to this entry, try to drop the shared
+			 * entry.
+			 */
+
+			/* only dropped entries can reach a 0 refcount */
+			Assert(shared_ref->shared_entry->dropped);
+
+			shent = dshash_find(pgStatSharedHash,
+								&shared_ref->shared_entry->key,
+								true);
+			if (!shent)
+				elog(PANIC, "could not find just referenced shared stats entry");
+
+			if (pg_atomic_read_u32(&shared_ref->shared_entry->refcount) != 0)
+				elog(PANIC, "concurrent access to stats entry during deletion");
+
+			Assert(shared_ref->shared_entry == shent);
+
+			/*
+			 * Fetch dsa pointer before deleting entry - that way we can free the
+			 * memory after releasing the lock.
+			 */
+			dsap = shent->body;
+
+			dshash_delete_entry(pgStatSharedHash, shent);
+
+			dsa_free(pgStatDSA, dsap);
+			shared_ref->shared_stats = NULL;
+		}
 	}
 
-	subentry = (PgStat_StatSubEntry *) hash_search(subscriptionStatHash,
-												   (void *) &subid,
-												   action, &found);
+	if (!pgstat_shared_ref_hash_delete(pgStatSharedRefHash, key))
+		elog(PANIC, "something has gone wrong");
 
-	if (!create && !found)
+	if (shared_ref)
+		pfree(shared_ref);
+}
+
+bool
+pgstat_shared_stat_lock(PgStatSharedRef *shared_ref, bool nowait)
+{
+	LWLock *lock = &shared_ref->shared_entry->lock;
+
+	if (nowait)
+		return LWLockConditionalAcquire(lock, LW_EXCLUSIVE);
+
+	LWLockAcquire(lock, LW_EXCLUSIVE);
+	return true;
+}
+
+void
+pgstat_shared_stat_unlock(PgStatSharedRef *shared_ref)
+{
+	LWLockRelease(&shared_ref->shared_entry->lock);
+}
+
+/*
+ * Helper function to fetch and lock shared stats.
+ */
+PgStatSharedRef *
+pgstat_shared_stat_locked(PgStatKind type, Oid dboid, Oid objoid, bool nowait)
+{
+	PgStatSharedRef *shared_ref;
+
+	/* find shared table stats entry corresponding to the local entry */
+	shared_ref = pgstat_shared_ref_get(type, dboid, objoid, true);
+
+	/* lock the shared entry to protect the content, skip if failed */
+	if (!pgstat_shared_stat_lock(shared_ref, nowait))
 		return NULL;
 
-	/* If not found, initialize the new one */
-	if (!found)
-		pgstat_reset_subscription(subentry, 0);
-
-	return subentry;
+	return shared_ref;
 }
 
-/* ----------
- * pgstat_reset_subscription
+/*
+ * The length of the data portion of a shared memory stats entry (i.e. without
+ * transient data such as refcoutns, lwlocks, ...).
+ */
+static inline size_t
+shared_stat_entry_len(PgStatKind kind)
+{
+	size_t		sz = pgstat_kind_infos[kind].shared_data_len;
+
+	AssertArg(kind <= PGSTAT_KIND_LAST);
+	Assert(sz != 0 && sz < PG_UINT32_MAX);
+
+	return sz;
+}
+
+/*
+ * Returns a pointer to the data portion of a shared memory stats entry.
+ */
+static inline void*
+shared_stat_entry_data(PgStatKind kind, PgStatShm_StatEntryHeader *entry)
+{
+	size_t		off = pgstat_kind_infos[kind].shared_data_off;
+
+	AssertArg(kind <= PGSTAT_KIND_LAST);
+	Assert(off != 0 && off < PG_UINT32_MAX);
+
+	return ((char *)(entry)) + off;
+}
+
+static bool
+pgstat_shared_refs_need_gc(void)
+{
+	uint64		currage;
+
+	if (!pgStatSharedRefHash)
+		return false;
+
+	currage = pg_atomic_read_u64(&pgStatShmem->gc_count);
+
+	return pgStatSharedRefAge != currage;
+}
+
+static void
+pgstat_shared_refs_gc(void)
+{
+	pgstat_shared_ref_hash_iterator i;
+	PgStatSharedRefHashEntry *ent;
+	uint64		currage;
+
+	currage = pg_atomic_read_u64(&pgStatShmem->gc_count);
+
+	/*
+	 * Some entries have been dropped. Invalidate cache pointer to
+	 * them.
+	 */
+	pgstat_shared_ref_hash_start_iterate(pgStatSharedRefHash, &i);
+	while ((ent = pgstat_shared_ref_hash_iterate(pgStatSharedRefHash, &i)) != NULL)
+	{
+		PgStatSharedRef *shared_ref = ent->shared_ref;
+
+		Assert(!shared_ref->shared_stats || shared_ref->shared_stats->magic == 0xdeadbeef);
+
+		/* cannot gc shared ref that has pending data */
+		if (shared_ref->pending != NULL)
+			continue;
+
+		if (shared_ref->shared_stats && shared_ref->shared_entry->dropped)
+			pgstat_shared_ref_release(ent->key, shared_ref);
+	}
+
+	pgStatSharedRefAge = currage;
+}
+
+/*
+ * Release all local references to shared stats entries.
  *
- * Reset the given subscription stats.
- * ----------
+ * When a process exits it cannot do so while still holding references onto
+ * stats entries, otherwise the shared stats entries could never be freed.
  */
 static void
-pgstat_reset_subscription(PgStat_StatSubEntry *subentry, TimestampTz ts)
+pgstat_shared_refs_release_all(void)
 {
-	subentry->apply_error_count = 0;
-	subentry->sync_error_count = 0;
-	subentry->stat_reset_timestamp = ts;
+	pgstat_shared_ref_hash_iterator i;
+	PgStatSharedRefHashEntry *ent;
+
+	if (pgStatSharedRefHash == NULL)
+		return;
+
+	pgstat_shared_ref_hash_start_iterate(pgStatSharedRefHash, &i);
+
+	while ((ent = pgstat_shared_ref_hash_iterate(pgStatSharedRefHash, &i))
+		   != NULL)
+	{
+		Assert(ent->shared_ref != NULL);
+
+		pgstat_shared_ref_release(ent->key, ent->shared_ref);
+	}
+
+	Assert(pgStatSharedRefHash->members == 0);
+	pgstat_shared_ref_hash_destroy(pgStatSharedRefHash);
+	pgStatSharedRefHash = NULL;
+}
+
+/*
+ * Returns the appropriate PgStatSharedRef, preparing it to receive pending
+ * stats if not already done.
+ */
+PgStatSharedRef*
+pgstat_pending_prepare(PgStatKind type, Oid dboid, Oid objoid)
+{
+	PgStatSharedRef *shared_ref;
+
+	shared_ref = pgstat_shared_ref_get(type, dboid, objoid, true);
+
+	if (shared_ref->pending == NULL)
+	{
+		size_t entrysize = pgstat_kind_infos[type].pending_size;
+
+		Assert(entrysize != (size_t)-1);
+
+		shared_ref->pending = MemoryContextAllocZero(TopMemoryContext, entrysize);
+		dlist_push_tail(&pgStatPending, &shared_ref->pending_node);
+	}
+
+	return shared_ref;
+}
+
+/*
+ * Return an existing stats entry, or NULL.
+ *
+ * This should only be used for helper function for pgstatfuncs.c - outside of
+ * that it shouldn't be needed.
+ */
+PgStatSharedRef*
+pgstat_pending_fetch(PgStatKind type, Oid dboid, Oid objoid)
+{
+	PgStatSharedRef *shared_ref;
+
+	shared_ref = pgstat_shared_ref_get(type, dboid, objoid, false);
+
+	if (shared_ref == NULL || shared_ref->pending == NULL)
+		return NULL;
+
+	return shared_ref;
+}
+
+static void
+pgstat_pending_delete(PgStatSharedRef *shared_ref)
+{
+	void *pending_data = shared_ref->pending;
+	PgStatKind kind;
+
+	Assert(pending_data != NULL);
+
+	/* FIXME: Move into a pgstat_kind_info callback */
+	kind = shared_ref->shared_entry->key.kind;
+	switch (kind)
+	{
+		case PGSTAT_KIND_TABLE:
+			pgstat_relation_delink(((PgStat_TableStatus *) pending_data)->relation);
+			break;
+		case PGSTAT_KIND_DB:
+		case PGSTAT_KIND_FUNCTION:
+		case PGSTAT_KIND_SUBSCRIPTION:
+			break;
+		default:
+			/* non-global stats should be explicitly handled */
+			Assert(pgstat_kind_infos[kind].is_global);
+			elog(ERROR, "unexpected");
+			break;
+	}
+
+	pfree(pending_data);
+	shared_ref->pending = NULL;
+
+	dlist_delete(&shared_ref->pending_node);
+}
+
+/*
+ * Flush out pending stats for database objects (databases, relations,
+ * functions).
+ */
+static bool
+pgstat_pending_flush_stats(bool nowait)
+{
+	bool		have_pending = false;
+	dlist_node *cur = NULL;
+
+	/*
+	 * Need to be a bit careful iterating over the list of pending
+	 * entries. Processing a pending entry may queue further pending entries
+	 * to the end of the list that we want to process, so a simple iteration
+	 * won't do. Further complicating matter is that we want to delete the
+	 * current entry in each iteration from the list if we flushed
+	 * successfully.
+	 *
+	 * So we just keep track of the next pointer in each loop iteration.
+	 */
+	if (!dlist_is_empty(&pgStatPending))
+		cur = dlist_head_node(&pgStatPending);
+
+	while (cur)
+	{
+		PgStatSharedRef *shared_ref
+			= dlist_container(PgStatSharedRef, pending_node, cur);
+		PgStatHashKey key;
+		bool		remove;
+		dlist_node *next;
+
+		key = shared_ref->shared_entry->key;
+
+		Assert(!pgstat_kind_infos[key.kind].is_global);
+		Assert(pgstat_kind_infos[key.kind].flush_pending_cb != NULL);
+
+		/* flush the stats, if possible */
+		remove = pgstat_kind_infos[key.kind].flush_pending_cb(shared_ref, nowait);
+
+		Assert(remove || nowait);
+
+		/* determine next entry, before deleting the pending entry */
+		if (dlist_has_next(&pgStatPending, cur))
+			next = dlist_next_node(&pgStatPending, cur);
+		else
+			next = NULL;
+
+		/* if successfully flushed, remove entry */
+		if (remove)
+			pgstat_pending_delete(shared_ref);
+		else
+			have_pending = true;
+
+		cur = next;
+	}
+
+	Assert(dlist_is_empty(&pgStatPending) == !have_pending);
+
+	return have_pending;
+}
+
+void
+pgstat_schedule_create(PgStatKind kind, Oid dboid, Oid objoid)
+{
+	int			nest_level = GetCurrentTransactionNestLevel();
+	PgStat_SubXactStatus *xact_state;
+	PgStat_PendingDroppedStatsItem *drop = (PgStat_PendingDroppedStatsItem *)
+		MemoryContextAlloc(TopTransactionContext, sizeof(PgStat_PendingDroppedStatsItem));
+
+	xact_state = pgstat_xact_stack_level_get(nest_level);
+
+	drop->is_create = true;
+	drop->item.kind = kind;
+	drop->item.dboid = dboid;
+	drop->item.objoid = objoid;
+
+	dlist_push_tail(&xact_state->pending_drops, &drop->node);
+	xact_state->pending_drops_count++;
+
+	/*
+	 * AFIXME: It would be a good idea to check if an object with that key
+	 * already exists. WARN if so, and reset the stats to 0.
+	 */
+}
+
+/*
+ * AFIXME: deduplicate with pgstat_schedule_create
+ * AFIXME: comment
+ * AFIXME: see notes about race conditions for functions in
+ *         pgstat_drop_function().
+ */
+void
+pgstat_schedule_drop(PgStatKind kind, Oid dboid, Oid objoid)
+{
+	int			nest_level = GetCurrentTransactionNestLevel();
+	PgStat_SubXactStatus *xact_state;
+	PgStat_PendingDroppedStatsItem *drop = (PgStat_PendingDroppedStatsItem *)
+		MemoryContextAlloc(TopTransactionContext, sizeof(PgStat_PendingDroppedStatsItem));
+
+	xact_state = pgstat_xact_stack_level_get(nest_level);
+
+	drop->is_create = false;
+	drop->item.kind = kind;
+	drop->item.dboid = dboid;
+	drop->item.objoid = objoid;
+
+	dlist_push_tail(&xact_state->pending_drops, &drop->node);
+	xact_state->pending_drops_count++;
+}
+
+/*
+ * Drop stats for the database and all the objects inside that database.
+ */
+void
+pgstat_drop_database_and_contents(Oid dboid)
+{
+	dshash_seq_status hstat;
+	PgStatShmHashEntry *p;
+	uint64		not_freed_count = 0;
+
+	Assert(OidIsValid(dboid));
+
+	Assert(pgStatSharedHash != NULL);
+
+	/* some of the dshash entries are to be removed, take exclusive lock. */
+	dshash_seq_init(&hstat, pgStatSharedHash, true);
+	while ((p = dshash_seq_next(&hstat)) != NULL)
+	{
+		if (p->dropped)
+			continue;
+
+		if (p->key.dboid == dboid)
+		{
+			/*
+			 * Even statistics for a dropped database might currently be
+			 * accessed (consider e.g. database stats for pg_stat_database).
+			 */
+			if (!pgstat_drop_stats_entry(&hstat))
+				not_freed_count++;
+		}
+	}
+	dshash_seq_term(&hstat);
+
+	/*
+	 * If some of the stats data could not be freed, signal the reference
+	 * holders to run garbage collection of their cached pgStatShmLookupCache.
+	 */
+	if (not_freed_count > 0)
+		pg_atomic_fetch_add_u64(&pgStatShmem->gc_count, 1);
+}
+
+/*
+ * Drop a shared stats entry. The entry must be exclusively locked.
+ *
+ * This marks the shared entry as dropped. However, the shared hash table
+ * entry and the stats entry are only deleted if there are no remaining
+ * references.
+ *
+ * Returns whether the stats data could be freed or not.
+ *
+ * AFIXME: This needs to be deduplicated with pgstat_shared_ref_release(). But
+ * it's not entirely trivial, because we can't use plain dshash_delete_entry()
+ * (but have to use dshash_delete_current()).
+ */
+static bool
+pgstat_drop_stats_entry(dshash_seq_status *hstat)
+{
+	PgStatShmHashEntry *ent;
+	PgStatHashKey key;
+	dsa_pointer pdsa;
+	bool		did_free;
+
+	ent = dshash_get_current(hstat);
+	key = ent->key;
+	pdsa = ent->body;
+
+	/*
+	 * Signal that the entry is dropped - this will eventually cause other
+	 * backends to release their references.
+	 */
+	Assert(!ent->dropped);
+	ent->dropped = true;
+
+	/*
+	 * This backend might very well be the only backend holding a
+	 * reference. Ensure that we're not preventing it from being cleaned up
+	 * till later.
+	 *
+	 * XXX: don't do this while holding the dshash lock.
+	 */
+	if (pgStatSharedRefHash)
+	{
+		PgStatSharedRefHashEntry *shared_ref_entry;
+
+		shared_ref_entry =
+			pgstat_shared_ref_hash_lookup(pgStatSharedRefHash, key);
+
+		if (shared_ref_entry && shared_ref_entry->shared_ref)
+		{
+			Assert(shared_ref_entry->shared_ref->shared_entry == ent);
+			pgstat_shared_ref_release(shared_ref_entry->key,
+									  shared_ref_entry->shared_ref);
+		}
+	}
+
+	/*
+	 * Now that the entry isn't needed anymore, remove the refcount
+	 * representing a valid entry. If that causes the refcount to reach 0 no
+	 * other backend can have a reference, so we can free.
+	 */
+	if (pg_atomic_fetch_sub_u32(&ent->refcount, 1) == 1)
+	{
+		dshash_delete_current(hstat);
+		dsa_free(pgStatDSA, pdsa);
+		did_free = true;
+	}
+	else
+	{
+		did_free = false;
+	}
+
+	return did_free;
+}
+
+static void
+pgstat_perform_drop(PgStat_DroppedStatsItem *drop)
+{
+	PgStatShmHashEntry *shent;
+	PgStatHashKey key;
+
+	key.kind = drop->kind;
+	key.dboid = drop->dboid;
+	key.objoid = drop->objoid;
+
+	if (pgStatSharedRefHash)
+	{
+		PgStatSharedRefHashEntry *lohashent;
+
+		lohashent = pgstat_shared_ref_hash_lookup(pgStatSharedRefHash, key);
+
+		if (lohashent)
+		{
+			if (lohashent->shared_ref && lohashent->shared_ref->pending)
+				pgstat_pending_delete(lohashent->shared_ref);
+
+			pgstat_shared_ref_release(lohashent->key, lohashent->shared_ref);
+		}
+	}
+
+	shent = dshash_find(pgStatSharedHash, &key, true);
+	if (shent)
+	{
+		dsa_pointer pdsa;
+
+		Assert(shent->body != InvalidDsaPointer);
+		pdsa = shent->body;
+
+		/*
+		 * Signal that the entry is dropped - this will eventually cause other
+		 * backends to release their references.
+		 */
+
+		if (shent->dropped)
+			elog(ERROR, "can only drop stats once");
+		shent->dropped = true;
+
+		if (pg_atomic_fetch_sub_u32(&shent->refcount, 1) == 1)
+		{
+			dshash_delete_entry(pgStatSharedHash, shent);
+			dsa_free(pgStatDSA, pdsa);
+		}
+		else
+		{
+			dshash_release_lock(pgStatSharedHash, shent);
+		}
+	}
+}
+
+
+/* ------------------------------------------------------------
+ * Fetching of stats
+ *------------------------------------------------------------
+ */
+
+static void
+pgstat_fetch_prepare(void)
+{
+	if (stats_snapshot.stats == NULL)
+	{
+		pgstat_setup_memcxt();
+
+		stats_snapshot.stats = pgstat_snapshot_create(pgStatSnapshotContext,
+													  PGSTAT_TABLE_HASH_SIZE,
+													  NULL);
+	}
+}
+
+static void
+pgstat_fetch_snapshot_build(void)
+{
+	dshash_seq_status hstat;
+	PgStatShmHashEntry *p;
+
+	pgstat_fetch_prepare();
+
+	Assert(stats_snapshot.stats->members == 0);
+
+	stats_snapshot.snapshot_timestamp = GetCurrentTimestamp();
+
+	/*
+	 * Build snapshot all variable stats.
+	 */
+	dshash_seq_init(&hstat, pgStatSharedHash, false);
+	while ((p = dshash_seq_next(&hstat)) != NULL)
+	{
+		bool found;
+		PgStatSnapshotEntry *entry = NULL;
+		size_t entry_len;
+		PgStatShm_StatEntryHeader *stats_data;
+
+		/*
+		 * Check if the stats object should be included in the
+		 * snapshot. Unless the stats kind can be accessed from all databases
+		 * (e.g. database stats themselves), we only include stats for the
+		 * current database or objects not associated with a database
+		 * (e.g. shared relations).
+		 */
+		if (p->key.dboid != MyDatabaseId &&
+			p->key.dboid != InvalidOid &&
+			!pgstat_kind_infos[p->key.kind].accessed_across_databases)
+			continue;
+
+		if (p->dropped)
+			continue;
+
+		Assert(pg_atomic_read_u32(&p->refcount) > 0);
+
+		stats_data = dsa_get_address(pgStatDSA, p->body);
+		Assert(stats_data);
+
+		entry = pgstat_snapshot_insert(stats_snapshot.stats, p->key, &found);
+		Assert(!found);
+
+		entry_len = pgstat_kind_infos[p->key.kind].shared_size;
+		entry->data = MemoryContextAlloc(pgStatSnapshotContext, entry_len);
+		memcpy(entry->data,
+			   shared_stat_entry_data(p->key.kind, stats_data),
+			   entry_len);
+	}
+	dshash_seq_term(&hstat);
+
+	/*
+	 * Build snapshot of all global stats.
+	 */
+	for (int kind = 0; kind < PGSTAT_KIND_LAST; kind++)
+	{
+		if (!pgstat_kind_infos[kind].is_global)
+		{
+			Assert(pgstat_kind_infos[kind].snapshot_cb == NULL);
+			continue;
+		}
+
+		Assert(pgstat_kind_infos[kind].snapshot_cb != NULL);
+
+		stats_snapshot.global_valid[kind] = false;
+
+		pgstat_kind_infos[kind].snapshot_cb();
+
+		Assert(!stats_snapshot.global_valid[kind]);
+		stats_snapshot.global_valid[kind] = true;
+	}
+
+	stats_snapshot.mode = STATS_FETCH_CONSISTENCY_SNAPSHOT;
+}
+
+void*
+pgstat_fetch_entry(PgStatKind type, Oid dboid, Oid objoid)
+{
+	PgStatHashKey key;
+	PgStatSharedRef *shared_ref;
+	void *stats_data;
+	size_t data_size;
+	size_t data_offset;
+
+	/* should be called from backends */
+	Assert(IsUnderPostmaster || !IsPostmasterEnvironment);
+
+	pgstat_fetch_prepare();
+
+	AssertArg(type <= PGSTAT_KIND_LAST);
+	AssertArg(!pgstat_kind_infos[type].is_global);
+
+	key.kind = type;
+	key.dboid = dboid;
+	key.objoid = objoid;
+
+	/* if we need to build a full snapshot, do so */
+	if (stats_snapshot.mode != STATS_FETCH_CONSISTENCY_SNAPSHOT &&
+		pgstat_fetch_consistency == STATS_FETCH_CONSISTENCY_SNAPSHOT)
+		pgstat_fetch_snapshot_build();
+
+	/* if caching is desired, look up in cache */
+	if (pgstat_fetch_consistency > STATS_FETCH_CONSISTENCY_NONE)
+	{
+		PgStatSnapshotEntry *entry = NULL;
+
+		entry = pgstat_snapshot_lookup(stats_snapshot.stats, key);
+
+		if (entry)
+			return entry->data;
+	}
+
+	/*
+	 * if we built a full snapshot and it's not in stats_snapshot.stats, it
+	 * doesn't exist.
+	 */
+	if (pgstat_fetch_consistency == STATS_FETCH_CONSISTENCY_SNAPSHOT)
+		return NULL;
+
+	stats_snapshot.mode = pgstat_fetch_consistency;
+
+	shared_ref = pgstat_shared_ref_get(type, dboid, objoid, false);
+
+	if (shared_ref == NULL || shared_ref->shared_entry->dropped)
+	{
+		/* FIXME: need to remember that STATS_FETCH_CONSISTENCY_CACHE */
+		return NULL;
+	}
+
+	/*
+	 * FIXME: For STATS_FETCH_CONSISTENCY_NONE, should we instead allocate
+	 * stats in calling context?
+	 */
+
+	data_size = pgstat_kind_infos[type].shared_data_len;
+	data_offset = pgstat_kind_infos[type].shared_data_off;
+	stats_data = MemoryContextAlloc(pgStatSnapshotContext, data_size);
+	memcpy(stats_data, ((char*) shared_ref->shared_stats) + data_offset, data_size);
+
+	if (pgstat_fetch_consistency > STATS_FETCH_CONSISTENCY_NONE)
+	{
+		PgStatSnapshotEntry *entry = NULL;
+		bool found;
+
+		entry = pgstat_snapshot_insert(stats_snapshot.stats, key, &found);
+		entry->data = stats_data;
+	}
+
+	return stats_data;
+}
+
+/*
+ * AFIXME: consistent naming
+ * AFIXME: deduplicate some of this code with pgstat_fetch_snapshot_build().
+ *
+ * AFIXME: it'd be nicer if we passed .snapshot_cb() the target memory
+ * location, instead of putting PgStatSnapshot into pgstat_internal.h
+ */
+void
+pgstat_snapshot_global(PgStatKind kind)
+{
+	AssertArg(kind <= PGSTAT_KIND_LAST);
+	AssertArg(pgstat_kind_infos[kind].is_global);
+
+	if (pgstat_fetch_consistency == STATS_FETCH_CONSISTENCY_SNAPSHOT)
+	{
+		if (stats_snapshot.mode != STATS_FETCH_CONSISTENCY_SNAPSHOT)
+			pgstat_fetch_snapshot_build();
+
+		Assert(stats_snapshot.global_valid[kind] == true);
+	}
+	else if (pgstat_fetch_consistency == STATS_FETCH_CONSISTENCY_NONE ||
+			 !stats_snapshot.global_valid[kind])
+	{
+		if (pgstat_fetch_consistency == STATS_FETCH_CONSISTENCY_NONE)
+			stats_snapshot.global_valid[kind] = false;
+
+		pgstat_kind_infos[kind].snapshot_cb();
+
+		Assert(!stats_snapshot.global_valid[kind]);
+		stats_snapshot.global_valid[kind] = true;
+	}
 }
